﻿using System;
using System.Collections.Generic;
using Ninject;
using System.Web.Mvc;
using Moq;
using Mvc_Ninject_Moq.Models;

namespace Mvc_Ninject_Moq.Infraestrutura
{
    public class NinjectDependencyResolver : IDependencyResolver
    {
        private IKernel kernel;
        public NinjectDependencyResolver(IKernel kernelParam)
        {
            kernel = kernelParam;
            AddBindings();
        }
        public object GetService(Type serviceType)
        {
            return kernel.TryGet(serviceType);
        }
        public IEnumerable<object> GetServices(Type serviceType)
        {
            return kernel.GetAll(serviceType);
        }
        private void AddBindings()
        {
            Mock<IProdutoRepositorio> mock = new Mock<IProdutoRepositorio>();

            mock.Setup(m => m.Produtos).Returns(new List<Produto> 
            {
                new Produto { Nome = "Teclado sem fio", Preco = 130 },
                new Produto { Nome = "Mouse Otico", Preco = 40 },
                new Produto { Nome = "Microfone", Preco = 15 },
                new Produto { Nome = "Pen Drive 8 GB", Preco = 59 },
                new Produto { Nome = "Fones de Ouvido", Preco = 19 }
            });

            kernel.Bind<IProdutoRepositorio>().ToConstant(mock.Object);
        }
    }
}